/*+- OmniWorks Replacement History - HzProducts`GenericComponents`ConsoleMgr`LauncherUI:LauncherUI.cs;35 */
/*      35*[529361] 06-JAN-2004 00:19:06 (GMT) HO */
/*         "forward Erika bug fixes" */
/*      34*[527064] 19-DEC-2003 22:22:08 (GMT) NJain2 */
/*         "PRD : Fabian - Exception when User creates a new Job with already existing Jobid" */
/*      33*[524662] 15-DEC-2003 22:35:37 (GMT) VSaxena2 */
/*         "JobLauncher are not visible completely when grouped with MC" */
/*      32*[523061] 10-DEC-2003 19:57:41 (GMT) NJain2 */
/*         "PRD : Fabian - Job Name, Well Name and Client Name are not mandatory in the Console manager." */
/*      31*[522560] 09-DEC-2003 02:13:23 (GMT) johnsen */
/*         "Add JobID and Well Name Parameters" */
/*      30*[519846] 03-DEC-2003 01:00:36 (GMT) nguyen */
/*         "Change the title of the Acquisition Console" */
/*      29*[516106] 21-NOV-2003 23:16:21 (GMT) sjia */
/*         "change parameters to MODIFIED_FREQUENTLY" */
/*      28*[508274] 19-NOV-2003 03:05:19 (GMT) johnsen */
/*         "Prevent job from being stopped when acq is running" */
/*      27*[506471] 28-OCT-2003 01:16:43 (GMT) johnsen */
/*         "Get rid of exceptions during resizing" */
/*      26*[505992] 25-OCT-2003 00:01:02 (GMT) johnsen */
/*         "Change shutdown sequence" */
/*      25*[505185] 24-OCT-2003 00:00:16 (GMT) johnsen */
/*         "Added handler for OnDisplayUnitChanged" */
/*      24*[504801] 22-OCT-2003 19:04:39 (GMT) johnsen */
/*         "." */
/*      23*[502073] 15-OCT-2003 19:37:02 (GMT) johnsen */
/*         "." */
/*      22*[496691] 03-OCT-2003 00:28:27 (GMT) johnsen */
/*         "More performance changes" */
/*      21*[494960] 27-SEP-2003 01:04:24 (GMT) johnsen */
/*         "Add JobGUID to environment variables" */
/*      20*[494676] 26-SEP-2003 16:18:01 (GMT) johnsen */
/*         "Use custom parameter for display unit" */
/*      19*[490696] 17-SEP-2003 00:54:46 (GMT) johnsen */
/*         "Performance improvements" */
/*      18*[486915] 04-SEP-2003 02:12:19 (GMT) johnsen */
/*         "Various updates" */
/*      17*[486452] 03-SEP-2003 02:12:16 (GMT) johnsen */
/*         "Changed "Well" to "Wellname"" */
/*      16*[483479] 28-AUG-2003 00:13:02 (GMT) johnsen */
/*         "Minor bug fix in GetAllJobs" */
/*      15*[481191] 19-AUG-2003 21:13:26 (GMT) johnsen */
/*         "Fix date issues" */
/*      14*[478643] 08-AUG-2003 23:14:35 (GMT) johnsen */
/*         "Disable drag & drop" */
/*      13*[470403] 18-JUL-2003 00:19:55 (GMT) johnsen */
/*         "Trim away leading and trailing whitespace characters" */
/*      12*[469826] 16-JUL-2003 15:48:17 (GMT) johnsen */
/*         "Added Subscribe() call for borehole collection" */
/*      11*[468361] 15-JUL-2003 00:34:48 (GMT) johnsen */
/*         "Bug fixes" */
/*      10*[463296] 27-JUN-2003 19:11:00 (GMT) RKamat */
/*         "PRD : To change the workflow parameter from TYPE1 to HZ_WORKFLOW_TYPE" */
/*       9*[462814] 26-JUN-2003 22:41:31 (GMT) RKamat */
/*         "PRD: Launcher UI - Change the way default settings are saved" */
/*       8*[461724] 25-JUN-2003 22:20:08 (GMT) RKamat */
/*         "Bug fix to Launcher UI" */
/*       7*[457797] 17-JUN-2003 01:53:06 (GMT) RKamat */
/*         "PRD : Launcher UI bug fix" */
/*       6*[457417] 12-JUN-2003 23:02:20 (GMT) RKamat */
/*         "Launcher UI changes" */
/*       5*[454544] 10-JUN-2003 14:04:42 (GMT) FOSTER */
/*         "add DnM session ensemble" */
/*       4*[452929] 04-JUN-2003 18:35:26 (GMT) HChauhan2 */
/*         "PRD: To modify for the Common Collection" */
/*       3*[447184] 19-MAY-2003 14:49:33 (GMT) RKamat */
/*         "PRD: Changes to Launcher UI" */
/*       2*[444726] 08-MAY-2003 14:02:11 (GMT) RKamat */
/*         "PRD: Changes to console Manager -  Assign parameters to set the environment variables" */
/*       1*[444046] 07-MAY-2003 14:38:18 (GMT) RKamat */
/*         "Launcher control" */
/*+- OmniWorks Replacement History - HzProducts`GenericComponents`ConsoleMgr`LauncherUI:LauncherUI.cs;35 */
using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Diagnostics;
using System.Windows.Forms;
using System.Xml;
using System.IO;
using System.Collections.Specialized;
using Syncfusion.Windows.Forms.Grid;

using ContextInfo;
using EventsInterface;

using Slb.Horizon.NewUIFramework;
using Slb.Horizon.Framework.Dsc;
using ExecutionManager;

namespace Slb.Horizon.UI.Widget
{
	public class LauncherUI : UIImpl
	{
		#region Designer variables
		private System.Windows.Forms.Button btnNew;
		private System.Windows.Forms.Button btnSideTrack;
		private System.Windows.Forms.Button btnStop;
		private System.Windows.Forms.Button btnStart;
		private System.ComponentModel.Container components = null;
	
		#endregion

		#region Private Member variables
		private DataTable dtJobs;
		private StringCollection Ulist; //Units list
		private StringCollection Wlist; // Workflow list
		private int oldWidth = -1;
		private int iNewRow;
		private string sessionID;
		private System.Windows.Forms.Label lblMsg;
		private string m_SelectedRowSessionID; //Maintains the sessionID. required to focus a row.
		
		private JobSetup.JobSetupClass m_objJobSetup = null;
		string m_DefaultWorkflow = "", m_DefaultUnit = "";
		
		private string m_FileNameDefaults = "Slb.Horizon.UI.Widget.LauncherUI.Defaults.xml";
		private string m_FullPathDefaults = null;

		AcqMeasurement.ParameterCollection m_ParamColl;
		ISlbDscQueryEx m_ParamQuery;
		AcqMeasurement.ParameterValueCollection m_ParamValueColl;
		ISlbDscQueryEx m_ParamValueQuery;
		
		DscSessionPackage.JobCollection m_objJobCol;
		ISlbDscQueryEx m_objJobQuery;
		WellPackage.WellCollection m_objWellCol;
		ISlbDscQueryEx m_objWellQuery;
		WellPackage.BoreholeCollection m_objBoreholeCol;
		ISlbDscQueryEx m_objBoreholeQuery;
		DscSessionPackage.SessionCollection m_objSessionCol;
		ISlbDscQueryEx m_objSessionQuery;

		private bool m_JobStarted = false;

		private string WLAcqEventName = "";
		private string DMAcqEventName = "";
		private bool acqRunning = false;

		private System.Windows.Forms.Panel panel1;
		private LauncherCustomizedDataGrid gridJob;
		#endregion

		#region Contructors and destructors
		public LauncherUI()
		{
			Microsoft.Win32.RegistryKey acqFwkKey = Microsoft.Win32.Registry.LocalMachine.OpenSubKey("Software\\Schlumberger\\Acquisition Framework");
			m_FullPathDefaults = acqFwkKey.GetValue("Templates", "").ToString() + @"\" + m_FileNameDefaults;

			InitializeComponent();
			Load += new EventHandler(LauncherUI_Load);
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}

			if ( gridJob != null ) gridJob.Dispose();
			m_objJobSetup = null;
			base.Dispose( disposing );
		}
		#endregion

		#region Derived methods
		protected override void OnInitialize()
		{
			try
			{
				Cursor = Cursors.WaitCursor;			
				
				InitGrid();

				m_objJobSetup = new JobSetup.JobSetupClass();
				m_objJobSetup.Init();
				
				m_objJobCol = (DscSessionPackage.JobCollection) m_objJobSetup.get_Collection("Job");
				if ( m_objJobCol == null ) throw new Exception("LauncherUI::OnInitialize - Unable to get Job collection.");
				m_objJobQuery = m_objJobCol as ISlbDscQueryEx;

				m_objWellCol = (WellPackage.WellCollection) m_objJobSetup.get_Collection("Well");
				if ( m_objWellCol == null ) throw new Exception("LauncherUI::OnInitialize - Unable to get Well collection.");
				m_objWellQuery = m_objWellCol as ISlbDscQueryEx;

				m_objBoreholeCol = (WellPackage.BoreholeCollection) m_objJobSetup.get_Collection("Borehole");
				if ( m_objBoreholeCol == null ) throw new Exception("LauncherUI::OnInitialize - Unable to get Borehole collection.");
				m_objBoreholeQuery = m_objBoreholeCol as ISlbDscQueryEx;

				m_objSessionCol = (DscSessionPackage.SessionCollection) m_objJobSetup.get_Collection("Session");
				if ( m_objSessionCol == null ) throw new Exception("LauncherUI::OnInitialize - Unable to get Session collection.");
				m_objSessionQuery = m_objSessionCol as ISlbDscQueryEx;

				m_ParamColl = new AcqMeasurement.ParameterCollectionClass();
				m_ParamValueColl = (AcqMeasurement.ParameterValueCollection) m_objJobSetup.get_Collection("Parameter_Value");
				if ( m_ParamValueColl == null ) throw new Exception("LauncherUI::OnInitialize - Unable to get ParameterValue collection.");
				m_ParamQuery = m_ParamColl as ISlbDscQueryEx;
				m_ParamValueQuery = m_ParamValueColl as ISlbDscQueryEx;

				LoadDefaultSettings();
				GetAllJobs();
               
				gridJob.Focus();
				Cursor = Cursors.Default;
			}
			catch (Exception e)
			{
				DisplayExceptionDetails(e);
			}
		}

		protected override bool OnDisplayUnitSystemChanged(string OldUnitSystem, string NewUnitSystem)
		{
			if ( m_JobStarted && current_row_idx >= 0 )
			{
				// This is a bit of a hack, but...
				gridJob[current_row_idx,6].Text = NewUnitSystem;
			}
			return false;
		}


		protected override bool OnClose()
		{
			SaveDefaultSettings();
			return false;
		}

		protected override bool OnPrint()
		{
			return false;
		}
		#endregion

		#region Component Designer generated code
		private void InitializeComponent()
		{
			Syncfusion.Windows.Forms.Grid.GridStyleInfo gridStyleInfo1 = new Syncfusion.Windows.Forms.Grid.GridStyleInfo();
			btnNew = new System.Windows.Forms.Button();
			btnSideTrack = new System.Windows.Forms.Button();
			btnStop = new System.Windows.Forms.Button();
			btnStart = new System.Windows.Forms.Button();
			lblMsg = new System.Windows.Forms.Label();
			panel1 = new System.Windows.Forms.Panel();
			gridJob = new LauncherCustomizedDataGrid();
			panel1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(gridJob)).BeginInit();
			SuspendLayout();
			// 
			// btnNew
			// 
			btnNew.FlatStyle = System.Windows.Forms.FlatStyle.System;
			btnNew.Location = new System.Drawing.Point(8, 8);
			btnNew.Name = "btnNew";
			btnNew.Size = new System.Drawing.Size(64, 24);
			btnNew.TabIndex = 1;
			btnNew.Text = "New";
			btnNew.Click += new System.EventHandler(btnNew_Click);
			// 
			// btnSideTrack
			// 
			btnSideTrack.Enabled = false;
			btnSideTrack.FlatStyle = System.Windows.Forms.FlatStyle.System;
			btnSideTrack.Location = new System.Drawing.Point(80, 8);
			btnSideTrack.Name = "btnSideTrack";
			btnSideTrack.Size = new System.Drawing.Size(64, 24);
			btnSideTrack.TabIndex = 2;
			btnSideTrack.Text = "SideTrack";
			// 
			// btnStop
			// 
			btnStop.Enabled = false;
			btnStop.FlatStyle = System.Windows.Forms.FlatStyle.System;
			btnStop.Location = new System.Drawing.Point(648, 8);
			btnStop.Name = "btnStop";
			btnStop.Size = new System.Drawing.Size(64, 24);
			btnStop.TabIndex = 4;
			btnStop.Text = "Stop";
			btnStop.Click += new System.EventHandler(btnStop_Click);
			// 
			// btnStart
			// 
			btnStart.Enabled = false;
			btnStart.FlatStyle = System.Windows.Forms.FlatStyle.System;
			btnStart.Location = new System.Drawing.Point(576, 8);
			btnStart.Name = "btnStart";
			btnStart.Size = new System.Drawing.Size(64, 24);
			btnStart.TabIndex = 3;
			btnStart.Text = "Start";
			btnStart.Click += new System.EventHandler(btnStart_Click);
			// 
			// lblMsg
			// 
			lblMsg.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			lblMsg.ForeColor = System.Drawing.Color.Green;
			lblMsg.Location = new System.Drawing.Point(264, 8);
			lblMsg.Name = "lblMsg";
			lblMsg.Size = new System.Drawing.Size(248, 24);
			lblMsg.TabIndex = 6;
			lblMsg.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// panel1
			// 
			panel1.Controls.Add(btnNew);
			panel1.Controls.Add(btnSideTrack);
			panel1.Controls.Add(lblMsg);
			panel1.Controls.Add(btnStart);
			panel1.Controls.Add(btnStop);
			panel1.Dock = System.Windows.Forms.DockStyle.Bottom;
			panel1.Location = new System.Drawing.Point(0, 200);
			panel1.Name = "panel1";
			panel1.Size = new System.Drawing.Size(720, 32);
			panel1.TabIndex = 7;
			panel1.Resize += new System.EventHandler(panel1_Resize);
			// 
			// gridJob
			// 
			gridJob.AllowResizeToFit = false;
			gridJob.ActivateCurrentCellBehavior = Syncfusion.Windows.Forms.Grid.GridCellActivateAction.SelectAll;
			gridJob.AllowDragSelectedCols = true;
			gridJob.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.AlphaBlend)));
			gridJob.ControllerOptions = Syncfusion.Windows.Forms.Grid.GridControllerOptions.None;
			gridJob.Dock = System.Windows.Forms.DockStyle.Fill;
			gridJob.EnableAddNew = false;
			gridJob.EnableRemove = false;
			gridJob.Font = new System.Drawing.Font("Tahoma", 8.25F);
			gridJob.Location = new System.Drawing.Point(0, 0);
			gridJob.MinResizeColSize = 2;
			gridJob.MinResizeRowSize = 2;
			gridJob.Name = "gridJob";
			gridJob.Properties.RowHeaders = false;
			gridJob.ResizeColsBehavior = Syncfusion.Windows.Forms.Grid.GridResizeCellsBehavior.None;
			gridJob.ResizeRowsBehavior = Syncfusion.Windows.Forms.Grid.GridResizeCellsBehavior.None;
			gridJob.VScrollBehavior = GridScrollbarMode.Enabled;
			gridJob.HScrollBehavior = GridScrollbarMode.Disabled;
			gridJob.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			gridJob.Size = new System.Drawing.Size(720, 200);
			gridJob.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.SingleClick;
			// gridJob.Model.Options.RefreshCurrentCellBehavior = GridRefreshCurrentCellBehavior.RefreshRow;
			gridJob.TabIndex = 8;
			gridJob.Model.Options.DataObjectConsumerOptions = GridDataObjectConsumerOptions.None;
			gridJob.Model.Options.DragDropDropTargetFlags = 0;
			gridJob.AllowDrop = false;
			gridStyleInfo1.Font.Bold = false;
			gridStyleInfo1.Font.Facename = "Tahoma";
			gridStyleInfo1.Font.Italic = false;
			gridStyleInfo1.Font.Size = 8.25F;
			gridStyleInfo1.Font.Strikeout = false;
			gridStyleInfo1.Font.Underline = false;
			gridJob.TableStyle = gridStyleInfo1;
			gridJob.ThemesEnabled = true;
			gridJob.VerticalThumbTrack = true;
			gridJob.CellDrawn += new Syncfusion.Windows.Forms.Grid.GridDrawCellEventHandler(gridJob_CellDrawn);
			gridJob.Resize += new System.EventHandler(gridJob_Resize);
			gridJob.CurrentCellChanged += new System.EventHandler(gridJob_CurrentCellChanged);
			gridJob.CurrentCellValidating += new System.ComponentModel.CancelEventHandler(gridJob_CurrentCellValidating);
			gridJob.CellDoubleClick += new Syncfusion.Windows.Forms.Grid.GridCellClickEventHandler(gridJob_CellDoubleClick);
			gridJob.CurrentCellActivating += new Syncfusion.Windows.Forms.Grid.GridCurrentCellActivatingEventHandler(gridJob_CurrentCellActivating);
			gridJob.PrepareViewStyleInfo += new Syncfusion.Windows.Forms.Grid.GridPrepareViewStyleInfoEventHandler(gridJob_PrepareViewStyleInfo);
			gridJob.QueryContinueDrag += new QueryContinueDragEventHandler(CancelQueryContinueDrag);
			gridJob.QueryCanOleDragRange += new GridQueryCanOleDragRangeEventHandler(CancelQueryCanOleDragRange);
			gridJob.Model.ClearingCells += new GridClearingCellsEventHandler(Model_ClearingCells);
			// 
			// LauncherUI
			// 
			AutoScroll = true;
			Controls.Add(gridJob);
			Controls.Add(panel1);
			Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			Name = "LauncherUI";
			Size = new System.Drawing.Size(720, 232);
			panel1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(gridJob)).EndInit();
			ResumeLayout(false);

		}
		#endregion

		#region Helpers
		internal XmlDocument tmpXmlDoc = new XmlDocument();
		#endregion

		#region Private Methods
		//Grid Initialization - adding columns and populating dropdown cells
		private void InitGrid()
		{			
			//Add the columns to the grid using a data table
			DataSet dsJobs = new DataSet();
			dtJobs = dsJobs.Tables.Add("Jobs");
			dtJobs.Columns.AddRange(
				new DataColumn[]{
									new DataColumn("Job",typeof(string)),
									new DataColumn("Wellname",typeof(string)),
									new DataColumn("Client",typeof(string)),
									new DataColumn("Start Date",typeof(System.DateTime)),
									new DataColumn("Workflow",typeof(string)),
									new DataColumn("Units",typeof(string)),
									new DataColumn("State",typeof(string)),
									new DataColumn("SideTrackId",typeof(int)),
									new DataColumn("SID",typeof(string)),
									new DataColumn("SortOrder",typeof(int)),
									new DataColumn("JobGUID",typeof(string)),
									new DataColumn("WellGUID",typeof(string)),
									new DataColumn("BoreholeGUID",typeof(string))});
			dtJobs.PrimaryKey = new DataColumn[]{dtJobs.Columns["SID"]};
			dtJobs.DefaultView.AllowNew = false;
			dtJobs.DefaultView.AllowDelete = false;

			//Set the data source on the grid
			gridJob.DataSource = dtJobs;
			gridJob.TableStyle.ReadOnly = false;
			gridJob.ControllerOptions = GridControllerOptions.All & (~GridControllerOptions.OleDataSource); 

			Ulist = new StringCollection();
			Ulist.Add("Canadian");
			Ulist.Add("English");
			Ulist.Add("Metric");

			Wlist = new StringCollection();
			Wlist.Add("D&M");
			Wlist.Add("Wireline");

			#region Set the formats for the columns
			gridJob.BeginUpdate();
			gridJob.Model.Cols.Hidden[8] = true; //sidetrack id column
			gridJob.Model.Cols.Hidden[9] = true; //session id column
			gridJob.Model.Cols.Hidden[10] = true; //sort order column
			gridJob.Model.Cols.Hidden[11] = true; //JobCode column
			gridJob.Model.Cols.Hidden[12] = true; //UWI column

			gridJob.BaseStylesMap["Standard"].StyleInfo.CellType = "Static";
			gridJob.SortColumn(4);
			
			GridBoundColumnsCollection gCoColl = gridJob.Binder.InternalColumns;
			
			GridBoundColumn col1 = gCoColl["Start Date"];			
			if ( col1 != null )
			{
				col1.ReadOnly = false;
				col1.StyleInfo.CellType = "MonthCalendar";
				col1.StyleInfo.Format = "dd-MMM-yyyy";
				col1.StyleInfo.CellType = "Static";
				
				col1.StyleInfo.HorizontalAlignment = GridHorizontalAlignment.Center;
			}
			GridBoundColumn col2 = gCoColl["Job"];
			if ( col2 != null )
			{
				col2.ReadOnly = false;
				col2.StyleInfo.HorizontalAlignment = GridHorizontalAlignment.Center;
				col2.StyleInfo.CellType = "Static";
				col2.StyleInfo.WrapText = true;
			}

			GridBoundColumn col3 = gCoColl["Workflow"];
			if ( col3 != null )
			{
				col3.ReadOnly = false;
				col3.StyleInfo.CellType = "Static";
				col3.StyleInfo.ChoiceList = Wlist;
				col3.StyleInfo.ExclusiveChoiceList = true;
			}
			GridBoundColumn col4 = gCoColl["Units"];
			if ( col4 != null )
			{
				col4.ReadOnly = false;
				col4.StyleInfo.CellType = "Static";
				col4.StyleInfo.ChoiceList = Ulist;
				col4.StyleInfo.ExclusiveChoiceList = true;
			}

			
			GridBoundColumn col5 = gCoColl["Wellname"];
			if ( col5 != null )
			{
				col5.ReadOnly = false;
				col5.StyleInfo.HorizontalAlignment = GridHorizontalAlignment.Center;
				col5.StyleInfo.CellType = "Static";
			}
			gridJob.BeginUpdate();
			
			GridBoundColumn col6 = gCoColl["Client"];
			if ( col6 != null )
			{
				col6.ReadOnly = false;
				col6.StyleInfo.HorizontalAlignment = GridHorizontalAlignment.Center;
				col6.StyleInfo.CellType = "Static";
			}
			
			GridBoundColumn col7 = gCoColl["State"];
			if ( col7 != null )
			{
				col7.ReadOnly = true;
				col7.StyleInfo.HorizontalAlignment = GridHorizontalAlignment.Center;
				col7.StyleInfo.CellType = "Static";
				col7.StyleInfo.Enabled = false;
			}
			gridJob.EndUpdate();
			#endregion
		}


		//Start the session for the selected row
		private void StartJob(int rowNo)
		{
			string job ="", well = "",client = "",workflow = "",unit = "",jobGUID = "", wellGUID = "", boreholeGUID = "";
			DateTime startdate;	
			bool IsJobSplChar, IsWellSplChar, IsClientSplChar;
			string newSession = "";

			try
			{
				if (rowNo != 0)
				{
					sessionID = "";
					btnStart.Enabled = false;
					btnSideTrack.Enabled = false;
					
					//get data from selected row
					job				= gridJob[rowNo,1].Text.Trim();						//job
					well			= gridJob[rowNo,2].Text.Trim();						//well
					client			= gridJob[rowNo,3].Text.Trim();						//client
					startdate		= (DateTime)(gridJob[rowNo,4].CellValue);			//start date
					workflow		= gridJob[rowNo,5].Text.Trim();						//workflow
					unit			= gridJob[rowNo,6].Text.Trim();						//Unit
					newSession		= gridJob[rowNo,9].Text.Trim();						//Session ID
					jobGUID			= gridJob[rowNo,11].Text.Trim();					//Job GUID
					wellGUID		= gridJob[rowNo,12].Text.Trim();					//Well GUID
					boreholeGUID	= gridJob[rowNo,13].Text.Trim();					//BoreHole GUID

					bool IsNewJob = newSession.StartsWith("New") ? true : false;

					if ( gridJob[rowNo,1].Text != job )
					{
						gridJob[rowNo,1].Text = job;
					}
					if ( gridJob[rowNo,2].Text != well )
					{
						gridJob[rowNo,2].Text = well;
					}
					if ( gridJob[rowNo,3].Text != client )
					{
						gridJob[rowNo,3].Text = client;
					}

					if ( IsNewJob )
					{
						// new job.
						#region Job validation
						IsJobSplChar = HasSplChar(job);
						if(IsJobSplChar)
						{
							MessageBox.Show("Job Name '" + job + "' has invalid characters.\n\", < and > are not allowed.\nPlease remove them from Job Name.","Bad input!",MessageBoxButtons.OK,MessageBoxIcon.Error);
							btnStart.Enabled = true;
							FocusRow(rowNo,1);
							return;
						}
						else if ( job.Length > 15 )
						{
							MessageBox.Show("Job Name '" + job + "' exceeds 15 characters.","Bad input!",MessageBoxButtons.OK,MessageBoxIcon.Error);
							btnStart.Enabled = true;
							FocusRow(rowNo,1);
							return;
						}
						#endregion

						#region Well Validation
						IsWellSplChar = HasSplChar(well);
						if (IsWellSplChar)
						{
							MessageBox.Show("Well Name '" + well + "' has invalid characters.\n\", < and > are not allowed.\nPlease remove them from Well Name.","Bad input!",MessageBoxButtons.OK,MessageBoxIcon.Error);
							btnStart.Enabled = true;
							FocusRow(rowNo,2);
							return;
						}
						else if (well.Length > 34)
						{
							MessageBox.Show("Well Name '" + well + "' exceeds 34 characters.","Bad input!",MessageBoxButtons.OK,MessageBoxIcon.Error);
							btnStart.Enabled = true;
							FocusRow(rowNo,2);
							return;

						}
						#endregion

						#region Client validation
						IsClientSplChar = HasSplChar(client);
						if (IsClientSplChar)
						{
							MessageBox.Show("Client Name '" + client + "' has invalid characters.\n\", < and > are not allowed.\nPlease remove them from Client Name.","Bad input!",MessageBoxButtons.OK,MessageBoxIcon.Error);
							btnStart.Enabled = true;
							FocusRow(rowNo,3);
							return;
						}
						else if (client.Length > 46)
						{
							MessageBox.Show("Client Name '" + client + "' exceeds 46 characters.","Bad input!",MessageBoxButtons.OK,MessageBoxIcon.Error);
							btnStart.Enabled = true;
							FocusRow(rowNo,3);
							return;

						}
						#endregion
						
						saveData(job,well,client,startdate,workflow,unit);
					}
					else
					{
						sessionID = newSession;
						CreateJob(job,jobGUID,boreholeGUID,workflow,unit,sessionID);
					}

					if (sessionID.Length != 0)
					{
						m_SelectedRowSessionID = sessionID;
						UpdateStateBySessionID("Started",sessionID);
						FocusRow(sessionID,-1);
						btnStart.Enabled = false;
						gridJob.Enabled = false;
						gridJob.BaseStylesMap["Standard"].StyleInfo.TextColor = Color.Gray;
						gridJob.Refresh();
						FocusRow(sessionID,-1);

						ConsoleMgrUI csmgr = GetControl(TopLevelControl);
						if ( csmgr != null )
							csmgr.ActivateConsoles();
					
						lblMsg.Text = job +  " Started";
						btnStop.Enabled = true;
						m_JobStarted = true;

						if ( workflow.Equals("Wireline") )
						{
							WLAcqEventName = "UISWLAcquisition.AcquisitionState:" + sessionID;
							SubscribeToFwkEventHost(WLAcqEventName, EventType_t.enum_UpdateNotify);
						}
						else if ( workflow.Equals("D&M") )
						{
							DMAcqEventName = "UISHSPMAcquisition.AcquisitionState:" + sessionID;
							SubscribeToFwkEventHost(DMAcqEventName, EventType_t.enum_UpdateNotify);
						}
					}
					else
					{						
						MessageBox.Show("Could not start the job","Oops!",MessageBoxButtons.OK,MessageBoxIcon.Warning);
						resetUI();
						Cursor = Cursors.Default;
					}
				}
			}
			catch
			{				
				MessageBox.Show("Could not start the job","Oops!",MessageBoxButtons.OK,MessageBoxIcon.Warning);
				resetUI();
				Cursor = Cursors.Default;
			}
		}

		private void saveData(string sJob, string sWell, string sClient, DateTime sStartDate, string sWorkflow, string sUnit)
		{
			int JobIndex;
			m_objJobCol.AddNewRow(out JobIndex);
			object JobGUID = m_objJobCol.get_ItemByIndex(JobIndex, JobTokens.GUID);
			m_objJobCol.set_ItemByIndex(JobIndex, JobTokens.JOBNAME, (object)sJob);
			m_objJobCol.set_ItemByIndex(JobIndex, JobTokens.JOBCODE, JobGUID);
			gridJob[iNewRow, 11].Text = JobGUID.ToString();
			m_objJobCol.set_ItemByIndex(JobIndex, JobTokens.ACTXSTARTDATE, (object)sStartDate);

			object BoreholeGUID, WellGUID;
			int WellIndex; 
			int BoreholeIndex;

			// Creating Well
			m_objWellCol.AddNewRow(out WellIndex);
			WellGUID = m_objWellCol.get_ItemByIndex(WellIndex, WellTokens.GUID);
			m_objWellCol.set_ItemByIndex(WellIndex, WellTokens.UWI, WellGUID);
			m_objWellCol.set_ItemByIndex(WellIndex, WellTokens.NAME, (object)sWell);
			gridJob[iNewRow, 12].Text = WellGUID.ToString();
			m_objWellCol.set_ItemByIndex(WellIndex, WellTokens.UWINAMING, (object)"ARBITRARY");
			m_objWellCol.set_ItemByIndex(WellIndex, WellTokens.STATUS, (object)"ACTIVE");
			
			// Creating borehole
			m_objBoreholeCol.AddNewRow(out BoreholeIndex);
			BoreholeGUID = m_objBoreholeCol.get_ItemByIndex(BoreholeIndex, BoreholeTokens.GUID);
			gridJob[iNewRow, 13].Text = BoreholeGUID.ToString();
			m_objBoreholeCol.set_ItemByIndex(BoreholeIndex, BoreholeTokens.NAME, (object)sWell);
			m_objBoreholeCol.set_ItemByIndex(BoreholeIndex, BoreholeTokens.UWI, BoreholeGUID);

			m_objBoreholeCol.set_ItemByIndex(BoreholeIndex, BoreholeTokens.UWINAMING, (object)"ARBITRARY");
			m_objBoreholeCol.set_ItemByIndex(BoreholeIndex, BoreholeTokens.BOREHOLESTATUS, (object)"ACTIVE");
			m_objBoreholeCol.set_ItemByIndex(BoreholeIndex, BoreholeTokens.BOREHOLEPURPOSE, (object)"DEVELOPMENT");
			m_objBoreholeCol.set_ItemByIndex(BoreholeIndex, BoreholeTokens.LOGMFERC, (object)"KB");
			m_objBoreholeCol.set_ItemByIndex(BoreholeIndex, BoreholeTokens.DRILLINGMFERC, (object)"KB");
			m_objBoreholeCol.AssociateContext(BoreholeIndex, m_objWellCol, (string)WellGUID);
			

			string prgID,wenv;
			if (sWorkflow.Equals("Wireline"))
			{
				wenv = "WIRELINE";
				prgID = "SlbHzPrdEns.WirelineSession";
			}
			else //d&m
			{
				wenv = "DnM";
				prgID = "SlbHzPrdEns.DnMSession"; 	//Need to know what to set for DnM		
			}

			int SessionIndex;
			m_objSessionCol.AddNewRow(out SessionIndex);
			m_objSessionCol.set_ItemByIndex(SessionIndex, SessionTokens.ENSEMBLECODE, (object)"Horizon Session");
			m_objSessionCol.set_ItemByIndex(SessionIndex, SessionTokens.ENSEMBLEPROGID, (object)prgID);
			m_objSessionCol.set_ItemByIndex(SessionIndex, SessionTokens.BOREHOLEGUID, BoreholeGUID);
			m_objSessionCol.set_ItemByIndex(SessionIndex, SessionTokens.WELLGUID, WellGUID);

			try
			{
				string FwkEnvVariable = Environment.GetEnvironmentVariable("HzFwkInstallDIR");
				FileVersionInfo myFileVersionInfo = FileVersionInfo.GetVersionInfo(FwkEnvVariable +@"\Bin\ExeJobManager.exe");
				string FwkVersion = myFileVersionInfo.FileVersion;
				m_objSessionCol.set_ItemByIndex(SessionIndex, SessionTokens.HZVERSION, FwkVersion);
			}
			catch ( System.Exception e )
			{
				//TODO: want to just silently write this to the message logger but can't from UI yet.
				this.DisplayExceptionDetails(e);
			}
			
			m_objSessionCol.AssociateContext(SessionIndex, m_objJobCol, (string)JobGUID);
			object SessionID = m_objSessionCol.get_ItemByIndex(SessionIndex, SessionTokens.GUID);

			CreateParameter(SessionID, "CN", sClient);
			CreateParameter(SessionID, "HZ_WORKFLOW_TYPE", sWorkflow);
			CreateParameter(SessionID, "HZ_DISPLAY_UNIT",  sUnit);
			CreateParameter(SessionID,"WN",sWell);
			CreateParameter(SessionID,"JOBID",sJob);
				
			sessionID = (string)SessionID;
			gridJob[rowNum(JobGUID.ToString(),11), 9].Text = sessionID;

			SetEnvironmentVariable("SessionID",SessionID);
			SetEnvironmentVariable("UnitSystem",sUnit);
			SetEnvironmentVariable("Workflow",wenv);
			SetEnvironmentVariable("BoreholeID",BoreholeGUID);
			SetEnvironmentVariable("JobGUID",JobGUID);
			SetEnvironmentVariable("JobName",sJob);
			
			m_DefaultWorkflow = sWorkflow;
			m_DefaultUnit = sUnit;

			m_objJobCol.Save();
			m_objWellCol.Save();
			m_objBoreholeCol.Save();
			m_objSessionCol.Save();
			m_ParamColl.Save();
			m_ParamValueColl.Save();
		}
		
		private void SaveDefaultSettings()
		{
			StreamWriter writer = new StreamWriter(m_FullPathDefaults,false,System.Text.Encoding.ASCII);

			string workFlow = m_DefaultWorkflow;
			if ( workFlow.Equals("D&M") )
				workFlow = "DnM";
			
			string defaultXml = 
				"<DefaultSettings>" +
				"<Workflow>" + workFlow + "</Workflow>" +
				"<Units>" + m_DefaultUnit + "</Units>" +
				"<NewCounter>" + m_NewCounter + "</NewCounter>" +
				"<RowsAreSorted>" + gridJob.RowsAreSorted + "</RowsAreSorted>" +
				"<SortIsAscending>" + gridJob.SortIsAscending + "</SortIsAscending>" +
				"<SortColumn>" + gridJob.CurrentSortColumn + "</SortColumn>" +
				"</DefaultSettings>";

			writer.Write(defaultXml);
			writer.Close();
		}

		private void LoadDefaultSettings()
		{				
			if (!File.Exists(m_FullPathDefaults))
			{
				m_DefaultWorkflow = "D&M";
				m_DefaultUnit = "English";
				m_NewCounter = 0;
			}
			else
			{
				try
				{
					XmlDocument xmlDoc = new XmlDocument();
					xmlDoc.Load(m_FullPathDefaults);

					m_DefaultWorkflow = xmlDoc["DefaultSettings"]["Workflow"].InnerText;
					if (m_DefaultWorkflow.Equals("DnM")) m_DefaultWorkflow = "D&M";
					
					m_DefaultUnit = xmlDoc["DefaultSettings"]["Units"].InnerText;

					m_NewCounter = int.Parse(xmlDoc["DefaultSettings"]["NewCounter"].InnerText);
					if ( m_NewCounter < 0 ) m_NewCounter = 0;

					bool rowsAreSorted = bool.Parse(xmlDoc["DefaultSettings"]["RowsAreSorted"].InnerText);
					if ( rowsAreSorted )
					{
						bool sortIsAscending = bool.Parse(xmlDoc["DefaultSettings"]["SortIsAscending"].InnerText);
						int sortColumn = int.Parse(xmlDoc["DefaultSettings"]["SortColumn"].InnerText);
						gridJob.SetSortParams(sortIsAscending,sortColumn);
					}
				}
				catch
				{
					m_DefaultWorkflow = "D&M";
					m_DefaultUnit = "English";
					m_NewCounter = 0;
				}
			}
		}

		//To reset the UI buttons if a job has failed to start
		private void resetUI()
		{
			btnNew.Enabled = true;
			btnStop.Enabled = false;
			gridJob.Enabled = true;
			gridJob.BaseStylesMap["Standard"].StyleInfo.TextColor = Color.Black;
			gridJob.Refresh();
			lblMsg.Text = "";
			btnStart.Enabled = true;
		}

		//Create job, well, borehole, session and set environment variables
		private void CreateJob(string sJobName, string sJobGuid, string sBoreholeGuid, string sWorkflow, string sUnit, string sessionID)
		{
			try
			{
				SetEnvironmentVariable("SessionID",sessionID);
				SetEnvironmentVariable("UnitSystem",sUnit);
				SetEnvironmentVariable("Workflow",(sWorkflow.Equals("Wireline")?"WIRELINE":"DnM"));
				SetEnvironmentVariable("BoreholeID",(object)sBoreholeGuid);
				SetEnvironmentVariable("JobGUID",(object)sJobGuid);
				SetEnvironmentVariable("JobName",sJobName);
			}
			catch(Exception e)
			{
				DisplayExceptionDetails(e);
			}
		}

		//get all info about jobs in database and populate the grid
		private void GetAllJobs()
		{
			object StoppedStr = (object)"Stopped";
			int zero = 0;
			object intZero = (object)zero;
			object oJob=null,oWell=null,oClient=null,oDate,oWorkflow=null,oUnit=null,oSessionID,oJobCode,oUWI;
			Array sessionList;
			int numSessions, numParameters, iJob, iWell;

			try
			{
				gridJob.BeginUpdate();
				gridJob.Binder.SuspendBinding();
				numSessions = m_objSessionCol.Count;
				for ( int i = 0;  i < numSessions;  ++i )
				{
					oSessionID = m_objSessionCol.get_ItemByIndex(i,SessionTokens.GUID);

					m_ParamValueQuery.ClearQuery();
					m_ParamValueQuery.set_QueryItem(ParameterValueTokens.ENTITYGUID, oSessionID);
					m_ParamValueQuery.PutQuery();
					m_ParamValueColl.Find(out sessionList);
					numParameters = sessionList.Length;
					for ( int j = 0;  j < numParameters;  ++j )
					{
						int idx = (int)sessionList.GetValue(j);
						string OSDDCode = (string)m_ParamValueColl.get_ItemByIndex(idx,ParameterValueTokens.OSDDCODE);
						switch ( OSDDCode )
						{
							case "CN" :
								oClient = m_ParamValueColl.get_ItemByIndex(idx,ParameterValueTokens.VALUE);
								break;
							case "HZ_DISPLAY_UNIT"	:
								oUnit = m_ParamValueColl.get_ItemByIndex(idx,ParameterValueTokens.VALUE);
								break;
							case  "HZ_WORKFLOW_TYPE" :
								oWorkflow = m_ParamValueColl.get_ItemByIndex(idx,ParameterValueTokens.VALUE);
								break;
							case "WN" :
								oWell = m_ParamValueColl.get_ItemByIndex(idx,ParameterValueTokens.VALUE);
								break;
							case "JOBID" :
								oJob = m_ParamValueColl.get_ItemByIndex(idx,ParameterValueTokens.VALUE);
								break;
							default	:
								break;
						}
					}

					iJob = m_objJobCol.get_Index((string)m_objSessionCol.get_ItemByIndex(i,SessionTokens.JOBGUID));
					if ( iJob >= 0 )
					{
						oDate = m_objJobCol.get_ItemByIndex(iJob,JobTokens.ACTXSTARTDATE);
						oJobCode   = m_objJobCol.get_ItemByIndex(iJob,JobTokens.JOBCODE);
					}
					else
					{
						oDate = null;
						oJobCode = null;
					}
					
					iWell = m_objWellCol.get_Index((string)m_objSessionCol.get_ItemByIndex(i,SessionTokens.WELLGUID));
					if ( iWell >= 0 )
					{
						oUWI   = m_objWellCol.get_ItemByIndex(iWell,WellTokens.UWI);
					}
					else
					{
						oUWI   = null;
					}

					dtJobs.LoadDataRow(new Object[]{oJob,oWell,oClient,oDate,oWorkflow,oUnit,StoppedStr,intZero,oSessionID,(object)i,oJobCode,oUWI},true);
				}
				gridJob.ScrollCellInView(1,1);
				FocusRow(dtJobs.Rows.Count,-1);
				gridJob.Binder.ResumeBinding();
				gridJob.EndUpdate();
				if (m_objJobCol.Count > 0) btnStart.Enabled = true;
			}
			catch(Exception e)
			{
				gridJob.EndUpdate();
				DisplayExceptionDetails(e);
				return;
			}
		}
		
		//Update State by session ID
		private void UpdateStateBySessionID(string state, string SID)
		{
			try
			{
				string cstate = ""; //current state
				int irowcount, rowIndex =0;

				irowcount = gridJob.Model.RowCount;
				
				//Identify the row that matches the session to get the current job running.
				for(int i=1; i<=irowcount; i++)
				{
					if (gridJob[i,9].Text == SID)
					{
						rowIndex = i;
						break;
					}
				}
				if (gridJob[rowIndex,7].Text.Equals("Started"))
					cstate = "Stopped";
				else if (gridJob[rowIndex,7].Text.Equals("Stopped"))
					cstate = "Started";
				else if (gridJob[rowIndex,7].Text.Length == 0)
					cstate = state;
	
				//update grid to display current status		
				gridJob.BeginUpdate();
				gridJob.Model.BeginUpdate();
				gridJob.Model.DiscardReadOnly = true;
				gridJob.Model[rowIndex,7].Text = cstate;
				gridJob[rowIndex,7].CellValue = cstate;
				gridJob[rowIndex,7].CellType = "Static";
				gridJob.Model.DiscardReadOnly = false;
				gridJob.Model.EndUpdate(false);
				gridJob.EndUpdate();
				gridJob.Refresh();
				gridJob.Binder.EndEdit();
				FocusRow(SID,-1);
			}
			catch(Exception e)
			{			
				DisplayExceptionDetails(e);
			}
		}

		//Focus a particular row
		private void FocusRow(string SID, int MoveToColumn)
		{
			int irowcount, rowIndex =0;
			irowcount = gridJob.Model.RowCount;
			int i;

			for(i=1; i<=irowcount; i++)
			{
				if (gridJob[i,9].Text == SID)
				{
					rowIndex = i;
					break;
				}
			}
			if (i == irowcount + 1)
				rowIndex = i+1;
			FocusRow(rowIndex,MoveToColumn);
		}
		
		private int current_row_idx = -1;
		private void FocusRow(int row_idx, int MoveToColumn)
		{
			if ( row_idx > 0 && ( current_row_idx != row_idx || MoveToColumn >= 0 ) )
			{
				int old_cri = current_row_idx;
				current_row_idx = row_idx;
				m_SelectedRowSessionID = gridJob[row_idx,9].Text;
				if ( MoveToColumn < 0 )
				{
					gridJob.ScrollCellInView(GridRangeInfo.Row(current_row_idx));
				}
				else
				{
					selectCellText(current_row_idx,MoveToColumn);
				}
				if ( old_cri >= 0 ) gridJob.RefreshRange(GridRangeInfo.Row(old_cri));
			}
			if ( btnStart.Enabled ) btnNew.Enabled = true;
			if ( btnNew.Enabled )
				btnSideTrack.Enabled = ((gridJob[current_row_idx,5].CellValue as string).Equals(@"D&M")) ? true : false;
			else
				btnSideTrack.Enabled = false;
		}
		
		private void gridJob_CurrentCellActivating(object sender, Syncfusion.Windows.Forms.Grid.GridCurrentCellActivatingEventArgs e)
		{
			if ( e.RowIndex > 0 && e.ColIndex > 0 )
				FocusRow(e.RowIndex,-1);
		}

		//To check if string has special characters of type ", < and > 
		private bool HasSplChar(string sinput)
		{
			int ilen = sinput.Length;
			
			for(int i=0; i<ilen; i++)
			{
				if ((sinput[i] == '<') || (sinput[i] == '>') || (sinput[i] == '"'))
					return true;
			}
			return false;
		}


		//To get the group control
		private ConsoleMgrUI GetControl(Control root)
		{
			for ( IEnumerator numbo = root.Controls.GetEnumerator();  numbo.MoveNext(); )
			{
				object obj = numbo.Current;
				if ( obj.GetType() == typeof(Slb.Horizon.UI.Widget.ConsoleMgrUI) )
				{
					ConsoleMgrUI csmg = obj as Slb.Horizon.UI.Widget.ConsoleMgrUI;
					return csmg;
				}
				else
				{
					try
					{
						Control ctrl = obj as System.Windows.Forms.Control;
						ConsoleMgrUI csmg = GetControl(ctrl);
						if ( csmg != null ) return csmg;
					}
					catch
					{
					}
				}
			}
			return null;
		}


		//Check and close running consoles
		private void StopConsoles(bool silent)
		{
			ConsoleMgrUI csmgr = GetControl(TopLevelControl);
			if ( csmgr != null )
			{
				if (csmgr.StopAllConsoles(silent))
				{
					csmgr.DeactivateConsoles();		
					
					if ( WLAcqEventName.Length > 0 )
					{
						UnSubscribeFromFwkEventHost(WLAcqEventName);
						WLAcqEventName = "";
					}
					if ( DMAcqEventName.Length > 0 )
					{
						UnSubscribeFromFwkEventHost(DMAcqEventName);
						DMAcqEventName = "";
					}

					btnStop.Enabled = false;
					gridJob.Enabled = true;

					gridJob.BaseStylesMap["Standard"].StyleInfo.TextColor = Color.Black;

					lblMsg.Text = "";
					gridJob.Refresh();
					btnStart.Enabled = true;
					btnNew.Enabled = true;
					m_JobStarted = false;
					UpdateStateBySessionID("Stopped",sessionID);
				}	
				else
				{
					btnStart.Enabled = false;
					btnNew.Enabled = false;
					btnStop.Enabled = true;
				}
			}
		}

		
		//Create a parameter for a OSDDcode
		private void CreateParameter(object SessionGUID, string paramCode, string paramValue)
		{
			try
			{
				int ParamIndex;
				m_ParamColl.AddNewRow(out ParamIndex);
				m_ParamColl.set_ItemByIndex(ParamIndex, ParameterTokens.INDEXOSDDCODE, "TIME_1900");
				m_ParamColl.set_ItemByIndex(ParamIndex, ParameterTokens.ENTITYGUID, SessionGUID);
				m_ParamColl.set_ItemByIndex(ParamIndex, ParameterTokens.ENSEMBLEGUID, SessionGUID);
				m_ParamColl.set_ItemByIndex(ParamIndex, ParameterTokens.TYPE, "PARA_TYPE_COMPUTATION_SETTING");
				m_ParamColl.set_ItemByIndex(ParamIndex, ParameterTokens.USAGELEVEL, "MODIFIED_FREQUENTLY");
				m_ParamColl.set_ItemByIndex(ParamIndex, ParameterTokens.OSDDCODE, paramCode);
				m_ParamColl.set_ItemByIndex(ParamIndex, ParameterTokens.CHANNELTYPE, "PARAMETER");

				string ParamGUID = m_ParamColl.get_ItemByIndex(ParamIndex, ParameterTokens.GUID) as string;

				int ParamValueIndex;
				m_ParamValueColl.AddNewRow(out ParamValueIndex);
				m_ParamValueColl.AssociateContext(ParamValueIndex, m_ParamColl, ParamGUID);
				m_ParamValueColl.set_ItemByIndex(ParamValueIndex, ParameterValueTokens.VALUE, paramValue);
				m_ParamValueColl.set_ItemByIndex(ParamValueIndex, ParameterValueTokens.DATE, DateTime.Today);
				m_ParamValueColl.set_ItemByIndex(ParamValueIndex, ParameterValueTokens.ISDELETED, false);
				m_ParamValueColl.set_ItemByIndex(ParamValueIndex, ParameterValueTokens.ISDEFAULT, false);
			}
			catch(Exception e)
			{
				DisplayExceptionDetails(e);
			}
		}


		private long UnitEnum(string unitSystem)
		{
			switch (unitSystem)
			{
				case "Canadian"	:
					return (long) UnitSystem.Canadian;
				case "English"	:
					return (long) UnitSystem.English;
				case "Metric"	:
					return (long) UnitSystem.Metric;
				case "Custom"	:
					return (long) UnitSystem.Custom;
				default	:
					return -1;
			}
		}


		//Select a particular text in cell
		private void selectCellText(int row, int col)
		{
			try
			{
				gridJob.Focus();
				gridJob.CurrentCell.Deactivate(false);
				gridJob.CurrentCell.MoveTo(row,col,GridSetCurrentCellOptions.ForceRefresh);
			}
			catch
			{
			}
		}
						   

		//return the row based on Value and column Index
		private int rowNum(string columnValue, int columnNum)
		{
			for (int i=1; i<=gridJob.Model.RowCount; i++)
			{
				if (gridJob[i,columnNum].Text == columnValue)
					return i;
			}
			return -1;
		}

	
		#region validation - objects already exist
		private int SessionExists(string ID)
		{
			return m_objSessionCol.get_Index(ID);
		}
		#endregion

		#endregion
		
		#region Event Handlers
		//Maintains the column widths proportionately
		private void gridJob_Resize(object sender, System.EventArgs e)
		{
			if ( !gridJob.Binder.InternalColumns.Contains("Job") ) return;
			int ww = gridJob.ClientSize.Width;
			if ( ( oldWidth > 0 && ww == oldWidth ) || ww <= 0)
				return;
			else
				oldWidth = ww;
			gridJob.BeginUpdate();
			if ( ww >= 510 )
			{
				int ww0 = (ww-360) / 2;
				int ww1 = (ww-360) - ww0;
				gridJob.Model.ColWidths["Job"] = 60;
				gridJob.Model.ColWidths["Wellname"] = ww0;  //150
				gridJob.Model.ColWidths["Client"] = ww1;    //200
				gridJob.Model.ColWidths["Start Date"] = 90;
				gridJob.Model.ColWidths["Workflow"] = 75;
				gridJob.Model.ColWidths["Units"] = 75;
				gridJob.Model.ColWidths["State"] = 60;
			}
			else
			{
				int dd = 510 - ww;
				int ddf = (dd+6) / 7;
				if ( dd > 0 ) 
				{
					int w = 60 - ddf;   w = w > 2 ? w : 2;
					gridJob.Model.ColWidths["Job"] = w;
					dd -= ( 60 - w );
					ddf = (dd+5) / 6;
				}
				if ( dd > 0 )
				{
					int w = 75 - ddf;   w = w > 2 ? w : 2;
					gridJob.Model.ColWidths["Wellname"] = w;
					dd -= ( 75 - w );
					ddf = (dd+4) / 5;
				}
				if ( dd > 0 )
				{
					int w = 75 - ddf;   w = w > 2 ? w : 2;
					gridJob.Model.ColWidths["Client"] = w;
					dd -= ( 75 - w );
					ddf = (dd+3) / 4;
				}
				if ( dd > 0 )
				{
					int w = 90 - ddf;   w = w > 2 ? w : 2;
					gridJob.Model.ColWidths["Start Date"] = w;
					dd -= ( 90 - w );
					ddf = (dd+2) / 3;
				}
				if ( dd > 0 )
				{
					int w = 75 - ddf;   w = w > 2 ? w : 2;
					gridJob.Model.ColWidths["Workflow"] = w;
					dd -= ( 75 - w );
					ddf = (dd+1) / 2;
				}
				if ( dd > 0 )
				{
					int w = 75 - ddf;   w = w > 2 ? w : 2;
					gridJob.Model.ColWidths["Units"] = w;
					dd -= ( 75 - w );
					ddf = dd;
				}
				if ( dd > 0 )
				{
					int w = 60 - ddf;   w = w > 2 ? w : 2;
					gridJob.Model.ColWidths["State"] = w;
				}
			}
			gridJob.EndUpdate(false);
			gridJob.Refresh();
		
		}

		//To get the required Date format
		private DateTime OldestAllowedStartDate = new DateTime(1899,12,31,23,59,59,999);
		private void gridJob_CurrentCellValidating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			GridCurrentCell cc = gridJob.CurrentCell;

			if(cc.Renderer.GetType() == typeof(GridDropDownMonthCalendarCellRenderer))
			{
				string format = gridJob[cc.RowIndex, cc.ColIndex].Format;
				string newValue = cc.Renderer.ControlText;
				
				try
				{
					if(format.Length > 0)
					{
						DateTime dt = DateTime.Parse(newValue);
						DateTime oldDt = (DateTime)gridJob[cc.RowIndex, cc.ColIndex].CellValue;
						if ( dt.Year == oldDt.Year && dt.Month == oldDt.Month && dt.Day == oldDt.Day )
						{
							dt = oldDt;
						}
						else
						{
							++m_NewCounter;
							dt = dt.AddSeconds((double)(m_NewCounter%86400));
						}

						if ( DateTime.Compare(OldestAllowedStartDate,dt) >= 0 )
						{
							MessageBox.Show("Start Date must be on or after Jan 1st 1900.","Bad Input!",MessageBoxButtons.OK,MessageBoxIcon.Error);
							e.Cancel = true;
						}
						else if (dt > DateTime.Now)
						{
							MessageBox.Show("Start Date cannot be in the future.","Bad Input!",MessageBoxButtons.OK,MessageBoxIcon.Error);
							e.Cancel = true;
						}
						else
						{
							string dateString = dt.ToString("G");
							cc.Renderer.Control.Text = dateString;
							//cc.Renderer.Control.Text = dt.ToString(format);
						}
					}
				}
				catch
				{
					e.Cancel = true;
					MessageBox.Show("Bad date string.","Bad Input!",MessageBoxButtons.OK,MessageBoxIcon.Error);
				}
			}
		}

		private void panel1_Resize(object sender, System.EventArgs e)
		{
			Control container = sender as Control;
			int y0 = ( container.Height - btnNew.Height ) / 2;
			btnNew.Location = new Point(8, y0);
			btnSideTrack.Location =  new Point(80, y0);
			btnStart.Location = new Point(container.Width - 144, y0);
			btnStop.Location = new Point(container.Width - 72, y0);
			int ww = btnStart.Location.X - btnSideTrack.Location.X - btnSideTrack.Width;
			if ( ww < 30 ) ww = 30;
			lblMsg.Width = ww;
			lblMsg.Location = new Point((container.Width-lblMsg.Width)/2, y0);
		}

		private int ComputeStaticSortingOrder(bool TurnOffSorting)
		{
			int i = 0;
			int csc = gridJob.CurrentSortColumn;
			if ( csc >= 0 )
			{
				int nrows = gridJob.Model.RowCount;
				for ( i = 1;  i <= nrows;  ++i )
				{
					string SID = gridJob[i,9].CellValue as string;
					DataRow row = dtJobs.Rows.Find(new object[]{SID});
					if ( row != null )
						row[9] = i;
				}
			}
			if ( TurnOffSorting && i > 0 ) gridJob.SetSortParams(true,10);
			return i;
		}

		//Create a new row with default values
		private int m_NewCounter = 0;
		private void btnNew_Click(object sender, System.EventArgs e)
		{
			Cursor = Cursors.WaitCursor;
			try
			{
				gridJob.BeginUpdate();
				gridJob.Binder.SuspendBinding();
				current_row_idx = -1;

				iNewRow = dtJobs.Rows.Count +1;

				int nextSortIndex = ComputeStaticSortingOrder(false);
				++m_NewCounter;

				string TmpSessionId = "New" + m_NewCounter.ToString();

				DateTime CurrentDate = DateTime.Today;
				CurrentDate = CurrentDate.AddSeconds((double)(m_NewCounter%86400));
				dtJobs.LoadDataRow(new Object[]{"","","",CurrentDate,m_DefaultWorkflow,m_DefaultUnit,"Stopped",0,TmpSessionId,nextSortIndex},true);
				if ( nextSortIndex > 0 ) gridJob.SetSortParams(true,10);
				gridJob.Binder.ResumeBinding();
				FocusRow(TmpSessionId,1);
				gridJob.EndUpdate();
				btnStart.Enabled = true;
				Cursor = Cursors.Default;
			}
			catch(Exception ex)
			{
				Cursor = Cursors.Default;
				DisplayExceptionDetails(ex);
			}
		}


		//Start a new session on double click
		private void gridJob_CellDoubleClick(object sender, Syncfusion.Windows.Forms.Grid.GridCellClickEventArgs e)
		{
			if ( e.RowIndex > 0 && e.ColIndex > 0 )
			{
				Cursor = Cursors.WaitCursor;
				
				gridJob.CurrentCell.EndEdit();	
				gridJob.Binder.EndEdit();
				if (e.RowIndex != 0)
				{
					btnNew.Enabled = false;
					StartJob(e.RowIndex);
				}
				FocusRow(m_SelectedRowSessionID,-1);
				Cursor = Cursors.Default;
			}
		}
	

		//Change the grid cells to static so as to make them non-editable
		private void gridJob_PrepareViewStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.GridPrepareViewStyleInfoEventArgs e)
		{
			if ( e.ColIndex < 1 || e.ColIndex > 7 || e.RowIndex < 1 ) return;
			try
			{
				iNewRow = gridJob.Model.RowCount;
				if((e.ColIndex != 0) && (e.RowIndex !=0))
				{
					if (gridJob[e.RowIndex,9].Text.StartsWith("New") )
					{
						switch (e.ColIndex)
						{
							case 1	: 
								e.Style.CellType = "TextBox";
								break;
							case 2	: 
								e.Style.CellType = "TextBox";
								break;
							case 3	: 
								e.Style.CellType = "TextBox";
								break;
							case 4	: 
								e.Style.CellType = "MonthCalendar";
								e.Style.Format = "dd-MMM-yyyy";
								break;
							case 5	: 
								e.Style.CellType = "ComboBox";
								e.Style.ChoiceList = Wlist;
								e.Style.ExclusiveChoiceList = true;
								break;
							case 6	: 
								e.Style.CellType = "ComboBox";
								e.Style.ChoiceList = Ulist;
								e.Style.ExclusiveChoiceList = true;
								break;
							case 7	: 
								e.Style.CellType = "Static";
								break;

						}
					}
				}
			}
			catch(Exception ex)
			{
				DisplayExceptionDetails(ex);
			}

		}

		//Stop the running session
		private void btnStop_Click(object sender, System.EventArgs e)
		{
			try
			{
				Cursor = Cursors.WaitCursor;
			
				StopConsoles(false);
				gridJob.Focus();

				Cursor = Cursors.Default;
			}
			catch (Exception ex)
			{				
				Cursor = Cursors.Default;
				DisplayExceptionDetails(ex);
			}
		}


		//Start the session for the selected  row
		private void btnStart_Click(object sender, System.EventArgs e)
		{
			if ( current_row_idx > 0 )
			{
				Cursor = Cursors.WaitCursor;

				gridJob.CurrentCell.EndEdit();	
				gridJob.Binder.EndEdit();
				btnNew.Enabled = false;

				StartJob(current_row_idx);
				Cursor = Cursors.Default;		
			}
		}

		//Enable/Disable the side track button based on workflow combobox
		private void gridJob_CurrentCellChanged(object sender, System.EventArgs e)
		{
			if ( gridJob.CurrentCell.ColIndex == 5 )
			{
				string workflow = gridJob.CurrentCell.Renderer.ControlText;
				btnSideTrack.Enabled = (workflow.Equals("D&M")) ? true : false;
			}
		}

		private void CancelQueryContinueDrag(object sender, QueryContinueDragEventArgs e)
		{
			e.Action = DragAction.Cancel;
		}

		private void CancelQueryCanOleDragRange(object sender, GridQueryCanOleDragRangeEventArgs e)
		{
			e.Cancel = true;
		}

		//all textbox columns get cleared when delete key is pressed after entering text
		// To avoid that use this event handler
		private void Model_ClearingCells(object sender, GridClearingCellsEventArgs e)
		{
			e.Handled = true;
		}

	
		private void gridJob_CellDrawn(object sender, Syncfusion.Windows.Forms.Grid.GridDrawCellEventArgs e)
		{
			if ( current_row_idx > 0 )
			{
				LauncherCustomizedDataGrid grid = sender as LauncherCustomizedDataGrid;
				if(grid != null)
				{
					if ( e.RowIndex == current_row_idx )
					{
						SolidBrush br = new SolidBrush(grid.AlphaBlendSelectionColor);
						e.Graphics.FillRectangle(br, e.Bounds);
						br.Dispose();
					}
				}
			}
		}

		private delegate void del_HandleFwkEvent(string Type, string Context, string SubscriberID);
		private void HandleOnUpdateNotify(string Type, string Context, string SubscriberID)
		{
			if ( Type.Equals(WLAcqEventName) )
			{
				tmpXmlDoc.LoadXml(Context);
				XmlNode stateNode = tmpXmlDoc.SelectSingleNode("Context/HardwareState");
				if ( stateNode == null )
				{
					return;
				}
				string state = stateNode.InnerText;
				if ( state.Equals("ACQUISITION_STATE_HARDWARE_CONNECTED") )
				{
					acqRunning = true;
				}
				else if ( state.Equals("ACQUISITION_STATE_HARDWARE_DISCONNECTED") )
				{
					acqRunning = false;
				}
				if ( m_JobStarted ) btnStop.Enabled = !acqRunning;
			}
			else if ( Type.Equals(DMAcqEventName) )
			{
				tmpXmlDoc.LoadXml(Context);
				XmlNode stateNode =  tmpXmlDoc.SelectSingleNode("Context/HspmAcquisitionState");
				if ( stateNode == null )
				{
					return;
				}
				string state = stateNode.InnerText;
				if ( state.Equals("ACQUISITION_STATE_DATA_FLOW_STARTED") )
				{
					acqRunning = true;
				}
				else if ( state.Equals("ACQUISITION_STATE_DATA_FLOW_STOPPED") )
				{
					acqRunning = false;
				}
				if ( m_JobStarted ) btnStop.Enabled = !acqRunning;
			}
		}
		protected override void OnUpdateNotify(string Type, string Context, string SubscriberID)
		{
			del_HandleFwkEvent UpdateEventHandler = new del_HandleFwkEvent(this.HandleOnUpdateNotify);
			this.BeginInvoke(UpdateEventHandler,new object[]{Type,Context,SubscriberID});
		}
		#endregion

		// HACK!
		// This function locates the outermost Form object and sets it's
		// MinimumSize property to avoid the LauncherUI getting squeezed.
		private void LauncherUI_Load(object sender, EventArgs e)
		{
			try
			{
				Form outermost_form = TopLevelControl as Form;
				outermost_form.MinimumSize = new Size(450,400);
			}
			catch
			{
			}
		}
	}

	public class LauncherCustomizedDataGrid : Syncfusion.Windows.Forms.Grid.GridDataBoundGrid
	{
		public LauncherCustomizedDataGrid()
		{
		}

		public override void SortColumn(int colIndex)
		{
			base.SortColumn (colIndex);
			if ( colIndex == currentSortColumn )
			{
				sortIsAscending = !sortIsAscending;
			}
			else
			{
				currentSortColumn = colIndex;
				rowsAreSorted = true;
				sortIsAscending = true;
			}
		}

		private bool rowsAreSorted = false;
		public bool RowsAreSorted
		{
			get
			{
				return rowsAreSorted;
			}
		}

		private int currentSortColumn = -1;
		public int CurrentSortColumn
		{
			get
			{
				return currentSortColumn;
			}
		}

		private bool sortIsAscending = true;
		public bool SortIsAscending
		{
			get
			{
				return sortIsAscending;
			}
		}

		public void SetSortParams(bool SortIsAscending, int SortColumn)
		{
			if ( rowsAreSorted && currentSortColumn == SortColumn )
			{
				if ( SortIsAscending != sortIsAscending )
				{
					base.SortColumn(SortColumn);
					sortIsAscending = SortIsAscending;
				}
			}
			else
			{
				if ( SortIsAscending )
				{
					base.SortColumn(SortColumn);
				}
				else
				{
					BeginUpdate();
					Binder.SuspendBinding();
					base.SortColumn(SortColumn);
					base.SortColumn(SortColumn);
					Binder.ResumeBinding();
					EndUpdate();
				}
				rowsAreSorted = true;
				sortIsAscending = SortIsAscending;
				currentSortColumn = SortColumn;
			}
		}
	}

	#region Enums
	public enum UnitSystem : long
	{
		Canadian = 0,
		English = 1,
		Metric = 2,
		Custom = 3
	}
	#endregion
}
